Skip to main content

Regular Expression Matching Leetcode Solution

Regular Expression Matching





Given an input string s and a pattern p, implement regular expression matching with support for '.' and '*' where:

'.' Matches any single character.​​​​

'*' Matches zero or more of the preceding element.


The matching should cover the entire input string (not partial).



Example 1:

Input: s = "aa", p = "a" 
Output: false 
Explanation: "a" does not match the entire string "aa".


Example 2:

Input: s = "aa", p = "a*" 
Output: true 
Explanation: '*' means zero or more of the preceding element, 'a'. Therefore, by repeating 'a' once, it becomes "aa".


Example 3:

Input: s = "ab", p = ".*" 
Output: true 
Explanation: ".*" means "zero or more (*) of any character (.)".



Constraints:

1 <= s.length <= 20
1 <= p.length <= 20
s contains only lowercase English letters.
p contains only lowercase English letters, '.', and '*'.
It is guaranteed for each appearance of the character '*', there will be a previous valid character to match.

Solution : 

class Solution {
public:
    bool isMatch(string s, string p) {

        vector<vector<bool>>dp(p.length() +1 , vector<bool>(s.length()+1 , false));
        for(int i =0 ; i < p.length() +1 ; i++)
        {
            for(int j =0 ; j < s.length() +1 ; j++)
            {
                if(i ==0 && j ==0)
                {
                    dp[i][j] = true;
                }
                else
                if(i ==0)
                {
                    dp[i][j] = false;
                }
                else
                if(j ==0)
                {
                    char pc = p[i-1];
                 
                    if(pc == '*')
                    {
                        dp[i][j] = dp[i-2][j];
                    }

                }
                else
                {
                    int pc = p[i-1];
                    int sc = s[j-1];
                    if(pc == sc || pc == '.' )
                    {
                        dp[i][j] = dp[i-1][j-1];
                    }
                    else
                    if(pc == '*')
                    {
                        dp[i][j] = dp[i-2][j];
                        if(p[i-2] == sc || p[i-2] == '.')
                        {
                            dp[i][j] = dp[i][j] || dp[i][j-1];
                        }
                    }
                 
                 
                 

                }
            }
         
        }
 

        return dp[p.length()][s.length()];
     
    }
};

Comments

Popular posts from this blog

[PDF DOWNLOAD] AKTU Quantum series data structure b.tech 2nd year download

  All AKTU Quantums are available here. Get your hands on AKTU Quantums and boost your grades in AKTU semester exams. You can either search them category wise or can use the search bar or can manually search on this page. Download aktu second year quantum pdf data structures  download  data structures quantum aktu download aktu data structures quantum click here to download  write in comment section if you want quantum of any other subject.

leetcode 48 solution

  48 .  Rotate Image You are given an  n x n  2D  matrix  representing an image, rotate the image by  90  degrees (clockwise). You have to rotate the image  in-place , which means you have to modify the input 2D matrix directly.  DO NOT  allocate another 2D matrix and do the rotation.   Example 1: Input: matrix = [[1,2,3],[4,5,6],[7,8,9]] Output: [[7,4,1],[8,5,2],[9,6,3]] Example 2: Input: matrix = [[5,1,9,11],[2,4,8,10],[13,3,6,7],[15,14,12,16]] Output: [[15,13,2,5],[14,3,4,1],[12,6,8,9],[16,7,10,11]]   Constraints: n == matrix.length == matrix[i].length 1 <= n <= 20 -1000 <= matrix[i][j] <= 1000 solution: class Solution { public:     void swap(int& a , int &b)     {         int c ;         c = a;         a = b;         b = c;     }     void transpose (vector<vector<int>...

solution : Snape and Ladder | codechef | Problem Code: SNAPE

  Snape and Ladder  Problem Code:  SNAPE Professor Snape has lots of potions. Bottles containing all types of potions are stacked on shelves which cover the entire wall from floor to ceiling. Professor Snape has broken his bones several times while climbing the top shelf for retrieving a potion. He decided to get a ladder for him. But he has no time to visit Diagon Alley. So he instructed Ron Weasley to make a ladder for him. Professor Snape specifically wants a step ladder which looks like an inverted 'V' from side view. Professor just mentioned two things before vanishing- B  - separation between left side (LS) and right side (RS) on the ground LS  - the length of left side What should be the length of  RS ? At one extreme  LS  can be vertical and at other  RS  can be vertical. Ron is angry and confused. Since Harry is busy battling Voldemort, its your duty to help him find the minimum and maximum length of  RS . Input First line ...